#include <stdio.h>
#include <stdlib.h>
#include "list.h"


void print_list(struct list *this) {
  printf("[");
  if (!this)
    printf(" ");
  else {
    printf("%c", this->head);
    this = this->tail;
    while (this) {
      printf(", %c", this->head);
      this = this->tail;
    }
  }
  printf("]");
}


struct list *construct_list_from_string(const char *s) {
  struct list *start; // punta all'elemento inziale della lista
  struct list *end;   // punta all'elemento finale della lista
  struct list *tmp;
  
  // Caso 1: la stringa s ' vuota
  // restituiamo la lista vuota
  if (!*s)
    return NULL;
  
  // Caso 2:la stringa s ha almeno un carattere
  // creiamo il primo elemento della lista
  // i puntatori start e end coincidono
  start = malloc(sizeof(struct list));
  start -> head = *s;
  start -> tail = NULL;
  end = start;
  
  while (*++s) {
    // creiamo un nuovo elemento della lista che corrisponde al carattere corrente
    tmp = malloc(sizeof(struct list));
    tmp -> head = *s;
    
    // l'elemento viene inserito alla fine della lista
    tmp -> tail = NULL; 
    end -> tail = tmp;
    
    // aggiorniamo il puntatore alla fine della lista
    end = tmp;
  }
  
  // restituiamo la lista creata
  return start;
}


// Variante ricorsiva ---
struct list *construct_list_from_string_ric(const char *s) {
  return *s ? construct_list(*s, construct_list_from_string_ric(s + 1)) : NULL;
}
// ---


struct list *construct_list(char head, struct list *tail) {
  struct list *this = malloc(sizeof(struct list));
  this->head = head;
  this->tail = tail;

  return this;
}


struct list *doppie(struct list *this) {
// precodizione: non ci sono piu' di due caratteri consecutivi uguali.
  if (!this || !this->tail)
    return NULL;
  else if (this->head == this->tail->head)
    return construct_list
      (this->head, construct_list(this->head, doppie(this->tail->tail)));
  else
    return doppie(this->tail);						    
}
